require "import"
import "android.widget.*"
import "com.androlua.*"
import "android.net.Uri"
import "android.content.Intent"

layout = {
  GridView,
  id = "grid",
  numColumns = 2,
  layout_width = "fill",
  layout_height = "fill"
}

items = {
  "إنشاء رابط لحساب telegram",
  "إنشاء رابط لحساب WhatsApp",
  "أحوال الطقس",
  "نسخ رابط التطبيق المفتوح إلى الحافظة",
  "مولد كلمات المرور"
}

dlg = LuaDialog(this)
dlg.View = loadlayout(layout)
grid.adapter = SingleLineAdapter(service, String(items))
dlg.setTitle("Tools Space")
dlg.setButton("خروج", nil)
dlg.show()

grid.onItemClick = function(l, v)
  dlg.dismiss()
  task(500, function()
    if v.text == "إنشاء رابط لحساب telegram" then 
      InputLayout = {
        LinearLayout;
        orientation = "vertical";
        {
          EditText;
          hint = "أدخل اسم المستخدم بدون @";
          id = "edit";
        };
        {
          Button;
          text = "مراسلة الحساب";
          onClick = function()
            if edit.text == "" then
              service.speak("قم بإدخال اسم المستخدم أولا")
            else
              this.startActivity(Intent(Intent.ACTION_VIEW,
                Uri.parse("https://t.me/"..edit.text)))
              service.click({{"%返回"}})
              service.playSoundTick()
              service.postClick(2000, {{"%Kembali",
                "%Kembali&batal*",
                "%Plugin/Anda mau menghubungi siapa/ari yudha"}})
            end
          end
        };
        {
          Button;
          text = "إنشاء رابط ونسخه";
          onClick = function()
            if edit.text == "" then
              service.speak("قم بإدخال اسم المستخدم أولا")
            else
              service.copy("https://t.me/"..edit.text)
              service.postSpeak(100, "تم إنشاء الرابط ونسخه إلى الحافظة")
            end
          end
        };
        {
          Button;
          text = "خروج";
          onClick = function()
            service.click({{"%返回"}})
          end
        };
      }

      dlg = LuaDialog()
      dlg.setTitle("إنشاء رابط لحساب Telegram")
      dlg.setView(loadlayout(InputLayout))
      dlg.show()
    elseif v.text == "إنشاء رابط لحساب WhatsApp" then
      InputLayout = {
        LinearLayout;
        orientation = "vertical";
        background = "#000000";  
        {
          TextView;
          text = "أدخل رقم الهاتف مع رمز الدولة:";
          textColor = "#FFFFFF";
          textSize = "16sp";
          layout_marginTop = "16dp";
          layout_marginLeft = "16dp";
        };
        {
          EditText;
          hint = "مثال: 966500123456";
          id = "edit";
          layout_marginLeft = "16dp";
          layout_marginRight = "16dp";
        };
        {
          Button;
          text = "إنشاء رابط وتساب ونسخه";
          onClick = function()
            if edit.text == "" then
              service.speak("قم بإدخال رقم الهاتف أولا")
            else
              local phoneNumber = edit.text
              local whatsappUrl = "https://wa.me/" .. phoneNumber
              service.copy(whatsappUrl)
              service.postSpeak(100, "تم إنشاء الرابط وتسخينه إلى الحافظة")
            end
          end
        };
        {
          Button;
          text = "خروج";
          onClick = function()
            service.click({{"%返回"}})
          end
        };
      }

      dlg = LuaDialog()
      dlg.setTitle("إنشاء رابط لحساب WhatsApp")
      dlg.setView(loadlayout(InputLayout))
      dlg.show()
    elseif v.text == "أحوال الطقس" then
      import "android.content.*"
      intent = Intent(Intent.ACTION_MAIN)
      intent.setComponent(ComponentName(
        "com.google.android.googlequicksearchbox",
        "com.google.android.apps.search.weather.WeatherExportedActivity"
      ))
      this.startActivity(intent)
      service.asyncSpeak("يتم عرض أحوال الطقس.")
      return true
    elseif v.text == "نسخ رابط التطبيق المفتوح إلى الحافظة" then
      local appName = this.getAppName(node)
      local appPackage = node.getPackageName()
      local appUrl = 'https://play.google.com/store/apps/details?id=' .. appPackage
      service.copy('رابط تطبيق\n' .. appName .. '\n' .. appUrl)
      service.postSpeak(300, 'تم نسخ رابط تطبيق ' .. appName .. ' إلى الحافظة')
      service.click({{"%Kembali"}})
setView(loadlayout(InputLayout))
    elseif v.text == "مولد كلمات المرور" then
      function generateRandomPassword(length)
        local chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789"
        local password = ""
        for i = 1, length do
            local randomIndex = math.random(1, #chars)
            password = password .. chars:sub(randomIndex, randomIndex)
        end
        return password
      end

      local passwordLength = 12
      local randomPassword = generateRandomPassword(passwordLength)
      print("كلمة المرور العشوائية: " .. randomPassword)
    end
  end)
end